
var statDialog;
var isconnected = 0;

var bundleVersion = '';
var usbVersion = '';
var dspVersion = '';

function onCloseVers() {
	//console.log('closing version window');
	
	close();
}

function clearVersion() {
  bundleVersion = '';
  usbVersion = '';
  dspVersion = '';
}

function setBundleVer() {
	span = document.getElementById('bundleVersion');
	txt = document.createTextNode(bundleVersion);
	span.innerText = txt.textContent;
}

function setUsbVer() {
	span = document.getElementById('usbVersion');
	txt = document.createTextNode(usbVersion);
	span.innerText = txt.textContent;
}

function setDspVer() {
  span = document.getElementById('dspVersion');
	txt = document.createTextNode(dspVersion);
	span.innerText = txt.textContent;
}

function setVersionInfo() {
	// set the text fields in the dialog now
  setBundleVer();
  setUsbVer();
  setDspVer();
}

function parseVersionString(laststat, content) {
	if (laststat === false) {
		dspVersion = 'unknown';
		usbVersion = 'unknown';
		setVersionInfo();
		statDialog.close();
		return;
	}

  var vstr = content.search("dle: "); 
  var dspv = content.search('DSP: ');

  if (vstr > 0) {
    bundleVersion = content.slice(vstr+4, dspv-1).trim();
  } 
   
	if (dspv > 0) {
		usbv = content.search('USB: ');
		if (usbv > 0 && usbv < dspv + 64) {
			dspVersion = content.slice(dspv + 4, usbv - 1).trim();
			usbVersion = content.slice(usbv + 4, usbv + 8).trim();
			//console.log('dsp=' + dspVersion + 'usb=' + usbVersion);			
			setVersionInfo();
		}
	}
	statDialog.close();
}

function hidGetVersion(cmd) {
  var bytes = new Uint8Array(1);
  console.log('connected via HID, waiting for data...');
  bytes[0] = cmd;

  chrome.hid.send(hidConnection.connId, HID_REPORT_ID, bytes.buffer, function() {
     if (chrome.runtime.lastError !== undefined) {
       console.warn('chrome.hid.send error: ' +
               chrome.runtime.lastError.message);
        return;
     }

     chrome.hid.receive(hidConnection.connId, function(reportId, data) {
        var inData = new Uint8Array(data);
        if (inData[0] > 3) {
          hidGetVersion(cmd);
          return;
        }
        
        switch(cmd) {
        case HID_CMD_GET_USB:
          usbVersion = inData;
          usbVersion[0] = usbVersion[1]+48;
          usbVersion[1] = '.';
          usbVersion[2] = usbVersion[2]+48;
          usbVersion = intToChar(usbVersion);
          usbVersion = usbVersion.slice(0, 3).trim();
          setUsbVer();
          break;
          
        case HID_CMD_GET_DSP:
          dspVersion = inData;
          dspVersion[0] = dspVersion[1]+48;
          dspVersion[1] = '.';
          dspVersion[2] = dspVersion[2]+48;
          dspVersion = intToChar(dspVersion);
          dspVersion = dspVersion.slice(0, 3).trim();
          setDspVer();
          break;
          
        case HID_CMD_GET_BUNDLE:  
          bundleVersion = intToChar(inData);
          bundleVersion = bundleVersion.slice(1, 10).trim();
          setBundleVer();
          break;
        }
     });
  });  
}


function doGetVersions() {
	statOp = document.getElementById('statusOp');
	txt = document.createTextNode('Getting Versions');
	statOp.innerText = txt.textContent;
	
	statText = document.getElementById('statusText');
	txt = document.createTextNode('Retrieving bundle version');
	statText.innerText = txt.textContent;
	
	clearVersion();
	setVersionInfo();

  //console.log('sending version command...');
  if (isHidConnected()) {
    for (var i=0; i<3; i++)
      hidGetVersion(HID_CMD_GET_BUNDLE-i);

    return;
	}
	
	statDialog.showModal();

	DataPacket_RunCommand(TARGET_VERSIONRETRIEVAL, 'Version Retrieval', 17, null, parseVersionString);
}

function onRetrieveVers() {
	//clearInterval();
	//console.log('get versions');
	if (! isconnected) {
		return; // almost impossible for this to happen
	} else {
		doGetVersions();
	}
}

function showDeviceState(connected) {
 
	span = document.getElementById('connstat');
	txt = document.createTextNode(connected.state);

	span.innerText = txt.textContent; 
	
	butt = document.getElementById('retver'); 
	butt.disabled = connected.state != 'Connected'; 
}

function updateConnStatus() {
	checkDevice(showDeviceState);
}

function onPlugDevice(device) {
	console.log('Plug device ' + device.vendorId + ':' + device.productId);
	updateConnStatus();
}

function onPullDevice(device) {
	console.log('Pulled device ' + device.vendorId + ':' + device.productId);
	updateConnStatus();
}

document.addEventListener('DOMContentLoaded', function () {
	//console.log('loaded version page');

	statDialog = document.getElementById('statusDialog');
	document.querySelector('#statusClose').onclick = function() {
		statDialog.close();
	};
	document.getElementById('canver').addEventListener('click', onCloseVers);
	document.getElementById('retver').addEventListener('click', onRetrieveVers);

	chrome.usb.onDeviceAdded.addListener(onPlugDevice);
	chrome.usb.onDeviceRemoved.addListener(onPullDevice);

	isconnected = -1;
	updateConnStatus();
	
	/* not needed, listening
	setInterval(updateConnStatus, 1000);
	*/
});

